/*
 *  PA_Frameworks.c
 *  4D Plugin
 *
 *  Created by miyako on 09/10/23.
 *  Copyright 2009 miyako. All rights reserved.
 *
 */

#include "PA_Frameworks.h"

#if VERSIONMAC
CFBundleRef CFBundleCopyFourdPrivateFrameworkByName( CFStringRef frameworkName ){
	
	CFBundleRef bundle;
	
	if(!_IsTiger()){
		
		CFURLRef frameworkUrl = CFBundleCopyPrivateFrameworksURL( CFBundleGetMainBundle() );
		CFURLRef openSSLUrl = CFURLCreateCopyAppendingPathComponent( kCFAllocatorDefault, frameworkUrl, frameworkName, TRUE );
		bundle = CFBundleCreate( kCFAllocatorSystemDefault, openSSLUrl );
		
		CFRelease(frameworkUrl);
		CFRelease(openSSLUrl);
		
	}else{
		
		CFArrayRef b_array = CFBundleGetAllBundles();
		
		if (b_array){
			CFRetain(b_array);
			CFURLRef b_url;
			CFStringRef b_str;
			CFBundleRef temp_bundle;
			int l_count = CFArrayGetCount(b_array);
			int i;
			
			for ( i = 0; i < l_count; ++i) {
				temp_bundle = (CFBundleRef)CFArrayGetValueAtIndex(b_array,i);
				CFRetain(temp_bundle);
				b_url = CFBundleCopyBundleURL(temp_bundle);
				b_str = CFURLGetString(b_url);
				CFRange b_range = CFStringFind(b_str, frameworkName, kCFCompareCaseInsensitive);
				if (b_url) CFRelease(b_url);
				if ( b_range.length && b_range.location != kCFNotFound && CFBundleIsExecutableLoaded(temp_bundle)){
					bundle = temp_bundle;
					break;
				}
				CFRelease(temp_bundle);
			}			
			CFRelease(b_array);
		}		
		
	}
	
	return bundle;
	
}

OSErr _GetSystemVersion( SInt32* SystemVersionMajor, SInt32* SystemVersionMinor, SInt32* SystemVersionBugFix )
{
	
	OSErr err = noErr;
	
	err = Gestalt( gestaltSystemVersionMajor, SystemVersionMajor );
	if(!err)
		err = Gestalt( gestaltSystemVersionMinor, SystemVersionMinor );
		if(!err)	
			err = Gestalt( gestaltSystemVersionBugFix, SystemVersionBugFix );

	return err;
	
}

Boolean _IsTiger(){
	
	SInt32 SystemVersionMajor, SystemVersionBugFix;
	SInt32 SystemVersionMinor = 0;
	
	_GetSystemVersion( &SystemVersionMajor, &SystemVersionMinor, &SystemVersionBugFix );

	return ( ( SystemVersionMinor == 4 ) ? 1 : 0 );
	
}
#endif