<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method="text" />
<xsl:template match="/">
<xsl:text>name:&#x9;</xsl:text>
<xsl:value-of select="/base/@name" />
<xsl:text>&#xA;uuid :&#x9;</xsl:text>
<xsl:value-of select="/base/@uuid" />
<xsl:text>&#xA;locale :&#x9;</xsl:text>
<xsl:value-of select="/base/@collation_locale" />
<xsl:text>&#xA;</xsl:text>
<xsl:text>tables:&#x9;</xsl:text>
<xsl:value-of select="count(//table)" />
<xsl:text>&#xA;</xsl:text>
<xsl:text>fields:&#x9;</xsl:text>
<xsl:value-of select="count(//field)" />
<xsl:text>&#xA;</xsl:text>
<xsl:text>indices:&#x9;</xsl:text>
<xsl:value-of select="count(//index)" />
<xsl:text>&#xA;</xsl:text>
<xsl:text>&#xA;</xsl:text>
<xsl:text>table name&#x9;table uuid&#x9;field name&#x9;field uuid&#x9;field type&#x9;unique&#x9;not null&#x9;never null&#x9;visible&#x9;mandatory&#x9;enterable&#x9;modifiable&#xA;</xsl:text>
 <xsl:apply-templates select="//table" />
</xsl:template>
<xsl:template match="//table">
<xsl:for-each select="./field">
<xsl:if test="position() = 1">
<xsl:value-of select="parent::node()/@name" />
</xsl:if>
<xsl:text>&#x9;</xsl:text>
<xsl:if test="position() = 1">
<xsl:value-of select="parent::node()/@uuid" />
</xsl:if>
<xsl:text>&#x9;</xsl:text>
<xsl:value-of select="@name" />
<xsl:text>&#x9;</xsl:text>
<xsl:value-of select="@uuid" />
<xsl:text>&#x9;</xsl:text>
<xsl:choose>
<xsl:when test="@type = 1">
<xsl:value-of select="'boolean'" />
</xsl:when>
<xsl:when test="@type = 3">
<xsl:value-of select="'integer'" />
</xsl:when>
<xsl:when test="@type = 4">
<xsl:value-of select="'long integer'" />
</xsl:when>
<xsl:when test="@type = 5">
<xsl:value-of select="'integer 64 bits'" />
</xsl:when>
<xsl:when test="@type = 6">
<xsl:value-of select="'real'" />
</xsl:when>
<xsl:when test="@type = 7">
<xsl:value-of select="'float'" />
</xsl:when>
<xsl:when test="@type = 8">
<xsl:value-of select="'date'" />
</xsl:when>
<xsl:when test="@type = 9">
<xsl:value-of select="'time'" />
</xsl:when>
<xsl:when test="@type = 12">
<xsl:value-of select="'picture'" />
</xsl:when>
<xsl:when test="@type = 14">
<xsl:value-of select="'text'" />
</xsl:when>
<xsl:when test="@type = 15">
<xsl:value-of select="'subtable'" />
</xsl:when>
<xsl:when test="@type = 16">
<xsl:value-of select="'subtable'" />
</xsl:when>
<xsl:when test="@type = 18">
<xsl:value-of select="'blob'" />
</xsl:when>
<xsl:when test="@type = 10">
<xsl:choose>
<xsl:when test="@limiting_length">
<xsl:value-of select="'alpha'" />
</xsl:when>
<xsl:otherwise>
<xsl:value-of select="'text'" />
</xsl:otherwise>
</xsl:choose>
</xsl:when>
</xsl:choose>
<xsl:if test="@type = 10">
<xsl:value-of select="@limiting_length" />
</xsl:if> 
<xsl:text>&#x9;</xsl:text>
<xsl:if test="@unique">
<xsl:value-of select="@unique" />
</xsl:if> 
<xsl:text>&#x9;</xsl:text>
<xsl:if test="@not_null">
<xsl:value-of select="@not_null" />
</xsl:if> 
<xsl:text>&#x9;</xsl:text>
<xsl:if test="@never_null">
<xsl:value-of select="@never_null" />
</xsl:if> 
<xsl:text>&#x9;</xsl:text>
<xsl:if test="field_extra/@visible">
<xsl:value-of select="field_extra/@visible" />
</xsl:if> 
<xsl:text>&#x9;</xsl:text>
<xsl:if test="field_extra/@mandatory">
<xsl:value-of select="field_extra/@mandatory" />
</xsl:if> 
<xsl:text>&#x9;</xsl:text>
<xsl:if test="field_extra/@enterable">
<xsl:value-of select="field_extra/@enterable" />
</xsl:if> 
<xsl:text>&#x9;</xsl:text>
<xsl:if test="field_extra/@modifiable">
<xsl:value-of select="field_extra/@modifiable" />
</xsl:if> 
<xsl:text>&#x9;</xsl:text>
<xsl:variable name="uuid">
<xsl:value-of select="@uuid" />
</xsl:variable>
<xsl:text>&#xA;</xsl:text>
</xsl:for-each>
<xsl:text>&#xA;</xsl:text>
</xsl:template>
</xsl:stylesheet>
