<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method="text" />
<xsl:template match="/">
 <xsl:apply-templates select="//table" />
</xsl:template>
<xsl:template match="//table">
<xsl:for-each select="./field">
<xsl:if test="position() = 1">
<xsl:text>CREATE TABLE </xsl:text>
<xsl:choose>
<xsl:when test="contains(parent::node()/@name, ' ') or 
contains(parent::node()/@name, '!') or 
contains(parent::node()/@name, '&amp;') or 
contains(parent::node()/@name, '^') or 
contains(parent::node()/@name, '#') or 
contains(parent::node()/@name, '%') 
 ">
<xsl:value-of select="concat('[', parent::node()/@name, ']')" />
</xsl:when>
<xsl:otherwise>
<xsl:value-of select="parent::node()/@name" />
</xsl:otherwise>
</xsl:choose>
<xsl:text> (&#xA;</xsl:text>
</xsl:if>
<xsl:text>&#x9;</xsl:text>
<xsl:choose>
<xsl:when test="contains(@name, ' ') or 
contains(@name, '!') or 
contains(@name, '&amp;') or 
contains(@name, '^') or 
contains(@name, '#') or 
contains(@name, '%') 
 ">
<xsl:value-of select="concat('[', @name, ']')" />
</xsl:when>
<xsl:otherwise>
<xsl:value-of select="@name" />
</xsl:otherwise>
</xsl:choose>
<xsl:text> </xsl:text>
<xsl:choose>
<xsl:when test="@type = 1">
<xsl:value-of select="'BOOLEAN'" />
</xsl:when>
<xsl:when test="@type = 3">
<xsl:value-of select="'SMALLINT'" />
</xsl:when>
<xsl:when test="@type = 4">
<xsl:value-of select="'INT'" />
</xsl:when>
<xsl:when test="@type = 5">
<xsl:value-of select="'NUMERIC'" />
</xsl:when>
<xsl:when test="@type = 6">
<xsl:value-of select="'REAL'" />
</xsl:when>
<xsl:when test="@type = 7">
<xsl:value-of select="'FLOAT'" />
</xsl:when>
<xsl:when test="@type = 8">
<xsl:value-of select="'TIMESTAMP'" />
</xsl:when>
<xsl:when test="@type = 9">
<xsl:value-of select="'DURATION'" />
</xsl:when>
<xsl:when test="@type = 12">
<xsl:value-of select="'PICTURE'" />
</xsl:when>
<xsl:when test="@type = 14">
<xsl:value-of select="'TEXT'" />
</xsl:when>
<xsl:when test="@type = 15">
<xsl:value-of select="'INT'" />
</xsl:when>
<xsl:when test="@type = 16">
<xsl:value-of select="'INT'" />
</xsl:when>
<xsl:when test="@type = 18">
<xsl:value-of select="'BLOB'" />
</xsl:when>
<xsl:when test="@type = 10">
<xsl:choose>
<xsl:when test="@limiting_length">
<xsl:value-of select="'VARCHAR'" />
<xsl:text>(</xsl:text>
<xsl:value-of select="@limiting_length" />
<xsl:text>)</xsl:text>
</xsl:when>
<xsl:otherwise>
<xsl:value-of select="'TEXT'" />
</xsl:otherwise>
</xsl:choose>
</xsl:when>
</xsl:choose>
<xsl:choose>
<xsl:when test="@unique">
<xsl:value-of select="' NOT NULL UNIQUE'" />
</xsl:when> 
<xsl:when test="(@not_null) and not(@unique)">
<xsl:value-of select="' NOT NULL'" />
</xsl:when> 
</xsl:choose>
<xsl:choose>
<xsl:when test="position() = last()">
<xsl:text>&#xA;);&#xA;</xsl:text>
</xsl:when>
<xsl:otherwise>
<xsl:text>,&#xA;</xsl:text>
</xsl:otherwise>
</xsl:choose>
</xsl:for-each>
<xsl:text>&#xA;</xsl:text>
</xsl:template>
</xsl:stylesheet>
